// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'SMEEngine.pas' rev: 5.00

#ifndef SMEEngineHPP
#define SMEEngineHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Db.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Smeengine
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TSMEColumnTitle;
class PASCALIMPLEMENTATION TSMEColumnTitle : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	AnsiString FCaption;
	Graphics::TColor FColor;
	Classes::TAlignment FAlignment;
	Graphics::TFont* FFont;
	void __fastcall SetFont(Graphics::TFont* Value);
	
public:
	__fastcall TSMEColumnTitle(void);
	__fastcall virtual ~TSMEColumnTitle(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property AnsiString Caption = {read=FCaption, write=FCaption};
	__property Classes::TAlignment Alignment = {read=FAlignment, write=FAlignment, default=0};
	__property Graphics::TFont* Font = {read=FFont, write=SetFont};
	__property Graphics::TColor Color = {read=FColor, write=FColor, default=12632256};
};


#pragma option push -b-
enum TSMEColumnKind { ckField, ckConstant };
#pragma option pop

#pragma option push -b-
enum TCellType { ctBlank, ctInteger, ctDouble, ctString, ctDateTime, ctDate, ctCurrency, ctTime };
#pragma option pop

class DELPHICLASS TSMEColumn;
class PASCALIMPLEMENTATION TSMEColumn : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	AnsiString FFieldName;
	Graphics::TColor FColor;
	int FWidth;
	int FPrecision;
	Graphics::TFont* FFont;
	Classes::TAlignment FAlignment;
	bool FVisible;
	TSMEColumnTitle* FTitle;
	TCellType FDataType;
	TSMEColumnKind FColumnKind;
	void __fastcall SetFont(Graphics::TFont* Value);
	void __fastcall SetTitle(TSMEColumnTitle* Value);
	
public:
	__fastcall virtual TSMEColumn(Classes::TCollection* Collection);
	__fastcall virtual ~TSMEColumn(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property Classes::TAlignment Alignment = {read=FAlignment, write=FAlignment, default=0};
	__property Graphics::TColor Color = {read=FColor, write=FColor, default=16777215};
	__property AnsiString FieldName = {read=FFieldName, write=FFieldName};
	__property Graphics::TFont* Font = {read=FFont, write=SetFont};
	__property int Width = {read=FWidth, write=FWidth, default=0};
	__property int Precision = {read=FPrecision, write=FPrecision, default=0};
	__property bool Visible = {read=FVisible, write=FVisible, nodefault};
	__property TSMEColumnTitle* Title = {read=FTitle, write=SetTitle};
	__property TCellType DataType = {read=FDataType, write=FDataType, default=3};
	__property TSMEColumnKind ColumnKind = {read=FColumnKind, write=FColumnKind, default=0};
};


class DELPHICLASS TSMEColumns;
class PASCALIMPLEMENTATION TSMEColumns : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	Classes::TComponent* FSMEControl;
	TSMEColumn* __fastcall GetColumn(int Index);
	void __fastcall SetColumn(int Index, TSMEColumn* Value);
	
protected:
	DYNAMIC Classes::TPersistent* __fastcall GetOwner(void);
	
public:
	__fastcall TSMEColumns(Classes::TComponent* SMECntrl);
	HIDESBASE TSMEColumn* __fastcall Add(void);
	int __fastcall ColumnByFieldName(const AnsiString AFieldName);
	__property TSMEColumn* Items[int Index] = {read=GetColumn, write=SetColumn/*, default*/};
	__property Classes::TComponent* SMEControl = {read=FSMEControl};
public:
	#pragma option push -w-inl
	/* TCollection.Destroy */ inline __fastcall virtual ~TSMEColumns(void) { }
	#pragma option pop
	
};


typedef void __fastcall (__closure *TSMEGetNext)(System::TObject* Sender, bool &Abort);

typedef void __fastcall (__closure *TSMEGetCount)(System::TObject* Sender, int &Count);

typedef void __fastcall (__closure *TSMEGetValue)(System::TObject* Sender, TSMEColumn* Column, Variant 
	&Value);

class DELPHICLASS TSMECustomDataEngine;
class PASCALIMPLEMENTATION TSMECustomDataEngine : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	bool FSelectedRecords;
	Classes::TNotifyEvent FOnFirst;
	TSMEGetNext FOnNext;
	TSMEGetCount FOnCount;
	Classes::TNotifyEvent FOnBeforeExecute;
	Classes::TNotifyEvent FOnAfterExecute;
	Classes::TNotifyEvent FOnFillColumns;
	TSMEGetValue FOnGetValue;
	
protected:
	bool IsCanceled;
	
public:
	virtual bool __fastcall SelectedRecordIsSupported(void);
	virtual void __fastcall EnableControls(void);
	virtual void __fastcall DisableControls(void);
	virtual void __fastcall SavePosition(void);
	virtual void __fastcall RestorePosition(void);
	virtual void __fastcall FillColumns(TSMEColumns* Columns, bool RightToLeft);
	virtual bool __fastcall IsDataRow(int Index);
	virtual bool __fastcall Eof(void);
	virtual void __fastcall First(void);
	virtual void __fastcall Next(void);
	virtual Variant __fastcall GetFieldValue(TSMEColumn* Column);
	virtual int __fastcall RecordCount(void);
	virtual Db::TFieldType __fastcall DataTypeByColumn(TSMEColumn* Column);
	virtual bool __fastcall RequiredByColumn(TSMEColumn* Column);
	virtual bool __fastcall ReadOnlyByColumn(TSMEColumn* Column);
	virtual Db::TField* __fastcall FindFieldByColumn(TSMEColumn* Column);
	__property bool SelectedRecords = {read=FSelectedRecords, write=FSelectedRecords, nodefault};
	
__published:
	__property Classes::TNotifyEvent OnFirst = {read=FOnFirst, write=FOnFirst};
	__property TSMEGetNext OnNext = {read=FOnNext, write=FOnNext};
	__property TSMEGetCount OnCount = {read=FOnCount, write=FOnCount};
	__property Classes::TNotifyEvent OnBeforeExecute = {read=FOnBeforeExecute, write=FOnBeforeExecute};
		
	__property Classes::TNotifyEvent OnAfterExecute = {read=FOnAfterExecute, write=FOnAfterExecute};
	__property Classes::TNotifyEvent OnFillColumns = {read=FOnFillColumns, write=FOnFillColumns};
	__property TSMEGetValue OnGetValue = {read=FOnGetValue, write=FOnGetValue};
public:
	#pragma option push -w-inl
	/* TComponent.Create */ inline __fastcall virtual TSMECustomDataEngine(Classes::TComponent* AOwner)
		 : Classes::TComponent(AOwner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TComponent.Destroy */ inline __fastcall virtual ~TSMECustomDataEngine(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSMEVirtualDataEngine;
class PASCALIMPLEMENTATION TSMEVirtualDataEngine : public TSMECustomDataEngine 
{
	typedef TSMECustomDataEngine inherited;
	
private:
	int intCurRow;
	
public:
	virtual void __fastcall First(void);
	virtual void __fastcall Next(void);
	virtual bool __fastcall Eof(void);
	virtual Variant __fastcall GetFieldValue(TSMEColumn* Column);
public:
	#pragma option push -w-inl
	/* TComponent.Create */ inline __fastcall virtual TSMEVirtualDataEngine(Classes::TComponent* AOwner
		) : TSMECustomDataEngine(AOwner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TComponent.Destroy */ inline __fastcall virtual ~TSMEVirtualDataEngine(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE TCellType __fastcall GetValueType(Db::TFieldType DataType, const Variant &Value, bool 
	BlankIfZero);
extern PACKAGE Db::TFieldType __fastcall CellType2FieldType(TCellType ct);

}	/* namespace Smeengine */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Smeengine;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// SMEEngine
